# CfnConnection

Creates a connection.

A connection defines the authorization type and credentials to use for authorization with an API destination HTTP endpoint.

For more information, see [Connections for endpoint targets](https://docs.aws.amazon.com/eventbridge/latest/userguide/eb-target-connection.html) in the *Amazon EventBridge User Guide* .

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnConnection
Implements: IInspectable, IEnvironmentAware, IConnectionRef, IConstruct, IDependable

- CloudFormation: [`AWS::Events::Connection`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-events-connection.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_events as events } from 'aws-cdk-lib';
const cfnConnection = new events.CfnConnection(this, 'MyCfnConnection', /* all optional props */ {
  authorizationType: 'authorizationType',
  authParameters: {
    apiKeyAuthParameters: {
      apiKeyName: 'apiKeyName',
      apiKeyValue: 'apiKeyValue',
    },
    basicAuthParameters: {
      password: 'password',
      username: 'username',
    },
    connectivityParameters: {
      resourceParameters: {
        resourceConfigurationArn: 'resourceConfigurationArn',

        // the properties below are optional
        resourceAssociationArn: 'resourceAssociationArn',
      },
    },
    invocationHttpParameters: {
      bodyParameters: [{
        key: 'key',
        value: 'value',

        // the properties below are optional
        isValueSecret: false,
      }],
      headerParameters: [{
        key: 'key',
        value: 'value',

        // the properties below are optional
        isValueSecret: false,
      }],
      queryStringParameters: [{
        key: 'key',
        value: 'value',

        // the properties below are optional
        isValueSecret: false,
      }],
    },
    oAuthParameters: {
      authorizationEndpoint: 'authorizationEndpoint',
      clientParameters: {
        clientId: 'clientId',
        clientSecret: 'clientSecret',
      },
      httpMethod: 'httpMethod',

      // the properties below are optional
      oAuthHttpParameters: {
        bodyParameters: [{
          key: 'key',
          value: 'value',

          // the properties below are optional
          isValueSecret: false,
        }],
        headerParameters: [{
          key: 'key',
          value: 'value',

          // the properties below are optional
          isValueSecret: false,
        }],
        queryStringParameters: [{
          key: 'key',
          value: 'value',

          // the properties below are optional
          isValueSecret: false,
        }],
      },
    },
  },
  description: 'description',
  invocationConnectivityParameters: {
    resourceParameters: {
      resourceConfigurationArn: 'resourceConfigurationArn',

      // the properties below are optional
      resourceAssociationArn: 'resourceAssociationArn',
    },
  },
  kmsKeyIdentifier: 'kmsKeyIdentifier',
  name: 'name',
});
```

## Initializer

```ts
new CfnConnection(scope: Construct, id: string, props?: CfnConnectionProps)
```

## Construct Props

- `authorizationType`: string — The type of authorization to use for the connection.

  > OAUTH tokens are refreshed when a 401 or 407 response is returned.

- `authParameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnConnection.AuthParametersProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_events.CfnConnection.AuthParametersProperty.html) — The authorization parameters to use to authorize with the endpoint.

  You must include only authorization parameters for the `AuthorizationType` you specify.

- `description`: string — A description for the connection to create.

- `invocationConnectivityParameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnConnection.InvocationConnectivityParametersProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_events.CfnConnection.InvocationConnectivityParametersProperty.html) — For connections to private APIs, the parameters to use for invoking the API.

  For more information, see [Connecting to private APIs](https://docs.aws.amazon.com/eventbridge/latest/userguide/connection-private.html) in the **Amazon EventBridge User Guide** .

- `kmsKeyIdentifier`: string — The identifier of the AWS customer managed key for EventBridge to use, if you choose to use a customer managed key to encrypt this connection.

  The identifier can be the key Amazon Resource Name (ARN), KeyId, key alias, or key alias ARN.

  If you do not specify a customer managed key identifier, EventBridge uses an AWS owned key to encrypt the connection.

  For more information, see [Identify and view keys](https://docs.aws.amazon.com/kms/latest/developerguide/viewing-keys.html) in the *AWS Key Management Service Developer Guide* .

- `name`: string — The name for the connection to create.

## Properties

- `attrArn`: string (required) — The ARN of the connection that was created by the request.

- `attrArnForPolicy`: string (required) — Returns the Amazon Resource Name (ARN) of a connection in resource format, so it can be used in the `Resource` element of IAM permission policy statements.

  For more information, see [Resource types defined by Amazon EventBridge](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazoneventbridge.html#amazoneventbridge-resources-for-iam-policies) in the *Service Authorization Reference* .

  For example, the following resource defines an IAM policy that grants permission to update a specific connection.

  `Resources: ExamplePolicy: Type: AWS::IAM::Policy Properties: PolicyName: ExamplePolicy PolicyDocument: Version: '2012-10-17 ' Statement: - Effect: Allow Action: - events:UpdateConnection Resource: - !GetAtt myConnection.ArnForPolicy`

- `attrAuthParametersConnectivityParametersResourceParametersResourceAssociationArn`: string (required) — For connections to private APIs, the Amazon Resource Name (ARN) of the resource association EventBridge created between the connection and the private API's resource configuration.

  > The value of this property is set by EventBridge . Any value you specify in your template is ignored.

- `attrInvocationConnectivityParametersResourceParametersResourceAssociationArn`: string (required) — For connections to private APIs, the Amazon Resource Name (ARN) of the resource association EventBridge created between the connection and the private API's resource configuration.

  > The value of this property is set by EventBridge . Any value you specify in your template is ignored.

- `attrSecretArn`: string (required) — The ARN for the secret created for the connection.

- `authorizationType`: string — The type of authorization to use for the connection.

- `authParameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnConnection.AuthParametersProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_events.CfnConnection.AuthParametersProperty.html) — The authorization parameters to use to authorize with the endpoint.

- `CFN_RESOURCE_TYPE_NAME`: string (required) (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) (required) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string (required) — AWS resource type.

- `connectionRef`: [ConnectionReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_events.ConnectionReference.html) (required) — A reference to a Connection resource.

- `creationStack`: string[] (required)

- `description`: string — A description for the connection to create.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html) (required)

- `invocationConnectivityParameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnConnection.InvocationConnectivityParametersProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_events.CfnConnection.InvocationConnectivityParametersProperty.html) — For connections to private APIs, the parameters to use for invoking the API.

- `kmsKeyIdentifier`: string — The identifier of the AWS customer managed key for EventBridge to use, if you choose to use a customer managed key to encrypt this connection.

- `logicalId`: string (required) — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `name`: string — The name for the connection to create.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) (required) — The tree node.

- `ref`: string (required) — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) (required) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForConnection(resource: IConnectionRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromConnectionArn(scope: Construct, id: string, arn: string): IConnectionRef` (static) — Creates a new IConnectionRef from an ARN.

- `fromConnectionName(scope: Construct, id: string, connectionName: string): IConnectionRef` (static) — Creates a new IConnectionRef from a connectionName.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnConnection(x: any): boolean` (static) — Checks whether the given object is a CfnConnection.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
